/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SENSOR_GROUP_T = 258,
     FLOWLABEL_GROUP_T = 259,
     DATERANGE_GROUP_T = 260,
     PATH_GROUP_T = 261,
     PARTITION_GROUP_T = 262,
     DOMAIN_T = 263,
     PROPERTY_T = 264,
     BEFORE_T = 265,
     AFTER_T = 266,
     WITH_T = 267,
     TO_T = 268,
     EQUALS = 269,
     SEMICOLON = 270,
     COLON = 271,
     DOLLAR = 272,
     COMMA = 273,
     PERIOD = 274,
     OPENBRACE = 275,
     CLOSEBRACE = 276,
     OPENBRACKET = 277,
     CLOSEBRACKET = 278,
     ID = 279,
     DATE = 280
   };
#endif
#define SENSOR_GROUP_T 258
#define FLOWLABEL_GROUP_T 259
#define DATERANGE_GROUP_T 260
#define PATH_GROUP_T 261
#define PARTITION_GROUP_T 262
#define DOMAIN_T 263
#define PROPERTY_T 264
#define BEFORE_T 265
#define AFTER_T 266
#define WITH_T 267
#define TO_T 268
#define EQUALS 269
#define SEMICOLON 270
#define COLON 271
#define DOLLAR 272
#define COMMA 273
#define PERIOD 274
#define OPENBRACE 275
#define CLOSEBRACE 276
#define OPENBRACKET 277
#define CLOSEBRACKET 278
#define ID 279
#define DATE 280




/* Copy the first part of user declarations.  */
#line 1 "cfg_parser.y"

/*
** Copyright (C) 2004-2007 by Carnegie Mellon University.
**
** @OPENSOURCE_HEADER_START@
**
** Use of the SILK system and related source code is subject to the terms
** of the following licenses:
**
** GNU Public License (GPL) Rights pursuant to Version 2, June 1991
** Government Purpose License Rights (GPLR) pursuant to DFARS 252.225-7013
**
** NO WARRANTY
**
** ANY INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY OR OTHER
** PROPERTY OR RIGHTS GRANTED OR PROVIDED BY CARNEGIE MELLON UNIVERSITY
** PURSUANT TO THIS LICENSE (HEREINAFTER THE "DELIVERABLES") ARE ON AN
** "AS-IS" BASIS. CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY
** KIND, EITHER EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING, BUT NOT
** LIMITED TO, WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE,
** MERCHANTABILITY, INFORMATIONAL CONTENT, NONINFRINGEMENT, OR ERROR-FREE
** OPERATION. CARNEGIE MELLON UNIVERSITY SHALL NOT BE LIABLE FOR INDIRECT,
** SPECIAL OR CONSEQUENTIAL DAMAGES, SUCH AS LOSS OF PROFITS OR INABILITY
** TO USE SAID INTELLECTUAL PROPERTY, UNDER THIS LICENSE, REGARDLESS OF
** WHETHER SUCH PARTY WAS AWARE OF THE POSSIBILITY OF SUCH DAMAGES.
** LICENSEE AGREES THAT IT WILL NOT MAKE ANY WARRANTY ON BEHALF OF
** CARNEGIE MELLON UNIVERSITY, EXPRESS OR IMPLIED, TO ANY PERSON
** CONCERNING THE APPLICATION OF OR THE RESULTS TO BE OBTAINED WITH THE
** DELIVERABLES UNDER THIS LICENSE.
**
** Licensee hereby agrees to defend, indemnify, and hold harmless Carnegie
** Mellon University, its trustees, officers, employees, and agents from
** all claims or demands made against them (and any related losses,
** expenses, or attorney's fees) arising out of, or relating to Licensee's
** and/or its sub licensees' negligent use or willful misuse of or
** negligent conduct or willful misconduct regarding the Software,
** facilities, or other rights or assistance granted by Carnegie Mellon
** University under this License, including, but not limited to, any
** claims of product liability, personal injury, death, damage to
** property, or violation of any laws or regulations.
**
** Carnegie Mellon University Software Engineering Institute authored
** documents are sponsored by the U.S. Department of Defense under
** Contract F19628-00-C-0003. Carnegie Mellon University retains
** copyrights in all material produced under this contract. The U.S.
** Government retains a non-exclusive, royalty-free license to publish or
** reproduce these documents, or allow others to do so, for U.S.
** Government purposes only pursuant to the copyright license under the
** contract clause at 252.227.7013.
**
** @OPENSOURCE_HEADER_END@
*/

/*
**  Parser data for config file parser
**
**  Sep 2004  Dave Svoboda
**
*/

#include "silk.h"

RCSIDENT("$SiLK: cfg_parser.y 7569 2007-06-18 16:08:47Z mthomas $");

#include "utils.h"
#include "cfg_lexer.h"
#include "cfg_config.h"


/* The current config structure we should add stuff to. */
static cfg_config_t *current_config = NULL;

/* The current domain we should add stuff to; part of the current config */
static cfg_map_t *current_domain = NULL;

/* Function to use for reporting errors */
static cfg_printf_function_t cfg_default_printf_function;

/* Set during grammar parsing */
static cfg_err_t cfg_yerrno;

/* Set of variables (only used to see what's been defined */
static cfg_map_t *cfg_vars_map = NULL;


/* Macros that wrap C functions around our own error recovery code */

/* Put two parens (( )) around your fprintf args in this call */
#define CFG_YPRINTF( args)                                      \
    if (0 > cfg_default_printf_function args) {                 \
        fprintf( stderr, "Error in reporting grammar error\n"); \
        cfg_yerrno = CFG_OUTPUT_ERROR;                          \
    }

/* Var must be previously declared to be a type*. */
#define CFG_YALLOCATE( type, var, degree)                     \
    var = CFG_CAST( type, MALLOC( (degree) * sizeof( type))); \
    if (NULL == var) {                                        \
        CFG_YPRINTF(( cfg_error_msg( CFG_OUT_OF_MEMORY)));    \
        cfg_yerrno = CFG_OUT_OF_MEMORY;                       \
    }

/* Sets cfg_yerrno if procedure returns an error */
#define CFG_YCHECK( procedure)                                          \
    {                                                                   \
        int err = CFG_OK;                                               \
        if (CFG_OK != (err = (procedure))) {                            \
            CFG_YPRINTF(( "Grammar Error: %s\n", cfg_error_msg( err))); \
            cfg_yerrno = err;                                           \
        }                                                               \
    }

/** YACC requires us to declare these fns here, but define them after
    grammar **/

static void cfg_map_add_from_grammar(
    cfg_map_t      *map,
    char           *key,
    cfg_array_t    *value,
    const char     *label);


static void cfg_map_variable_values(
    cfg_array_t               **result,
    const cfg_map_t            *map,
    const char                 *key,
    const char                 *label,
    const cfg_clone_function_t  clone_function);


static void cfg_path_cross_product(
    cfg_array_t       **result,
    const cfg_array_t  *sensors,
    const cfg_array_t  *flowlabels,
    cfg_array_t        *dateranges);


cfg_err_t cfg_config_read(
    cfg_config_t               *x,
    FILE                       *input,
    const cfg_printf_function_t error_fn);




/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 145 "cfg_parser.y"
typedef union YYSTYPE {
    char *string;
    cfg_array_t *array;
    cfg_date_t *date;
    cfg_daterange_t *daterange;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 278 "cfg_parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 290 "cfg_parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  22
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   100

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  26
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  31
/* YYNRULES -- Number of rules. */
#define YYNRULES  54
/* YYNRULES -- Number of states. */
#define YYNSTATES  107

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   280

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    13,    15,    17,
      19,    25,    28,    30,    34,    36,    40,    42,    44,    46,
      52,    55,    57,    61,    63,    67,    69,    71,    73,    78,
      80,    84,    86,    89,    95,   100,   102,   106,   108,   112,
     114,   118,   123,   128,   134,   137,   139,   143,   145,   149,
     151,   153,   157,   160,   163
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      27,     0,    -1,    -1,    28,    27,    -1,    29,    -1,    35,
      -1,    49,    -1,    50,    -1,    41,    -1,     1,    -1,     4,
      30,    14,    31,    15,    -1,    17,    24,    -1,    33,    -1,
      20,    32,    21,    -1,    33,    -1,    33,    18,    32,    -1,
      30,    -1,    34,    -1,    24,    -1,     3,    36,    14,    37,
      15,    -1,    17,    24,    -1,    39,    -1,    20,    38,    21,
      -1,    39,    -1,    39,    18,    38,    -1,    36,    -1,    40,
      -1,    24,    -1,     8,    24,    42,    15,    -1,    44,    -1,
      20,    43,    21,    -1,    42,    -1,    42,    43,    -1,     6,
      45,    14,    46,    15,    -1,    17,    24,    16,    24,    -1,
      48,    -1,    20,    47,    21,    -1,    48,    -1,    48,    18,
      47,    -1,    45,    -1,    37,    19,    31,    -1,    37,    19,
      31,    52,    -1,     9,    24,    24,    15,    -1,     5,    51,
      14,    52,    15,    -1,    17,    24,    -1,    54,    -1,    20,
      53,    21,    -1,    54,    -1,    54,    18,    53,    -1,    51,
      -1,    55,    -1,    56,    13,    56,    -1,    10,    56,    -1,
      11,    56,    -1,    25,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   185,   185,   186,   195,   196,   197,   198,   199,   204,
     211,   218,   224,   225,   231,   232,   239,   245,   251,   256,
     263,   269,   270,   276,   277,   284,   290,   296,   301,   309,
     310,   314,   315,   319,   328,   345,   346,   352,   353,   360,
     365,   371,   381,   389,   396,   402,   403,   409,   410,   417,
     423,   429,   434,   439,   444
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SENSOR_GROUP_T", "FLOWLABEL_GROUP_T",
  "DATERANGE_GROUP_T", "PATH_GROUP_T", "PARTITION_GROUP_T", "DOMAIN_T",
  "PROPERTY_T", "BEFORE_T", "AFTER_T", "WITH_T", "TO_T", "EQUALS",
  "SEMICOLON", "COLON", "DOLLAR", "COMMA", "PERIOD", "OPENBRACE",
  "CLOSEBRACE", "OPENBRACKET", "CLOSEBRACKET", "ID", "DATE", "$accept",
  "input", "decl", "flowlabel_decl", "flowlabel_var", "flowlabel_set",
  "flowlabel_entries", "flowlabel_entry", "flowlabel", "sensor_decl",
  "sensor_var", "sensor_set", "sensor_entries", "sensor_entry", "sensor",
  "domain_decl", "path_decl_set", "path_decl_set2", "path_decl",
  "path_var", "path_set", "path_entries", "path_entry", "property_decl",
  "daterange_decl", "daterange_var", "daterange_set", "daterange_entries",
  "daterange_entry", "daterange", "date", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    26,    27,    27,    28,    28,    28,    28,    28,    28,
      29,    30,    31,    31,    32,    32,    33,    33,    34,    35,
      36,    37,    37,    38,    38,    39,    39,    40,    41,    42,
      42,    43,    43,    44,    45,    46,    46,    47,    47,    48,
      48,    48,    49,    50,    51,    52,    52,    53,    53,    54,
      54,    55,    55,    55,    56
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       5,     2,     1,     3,     1,     3,     1,     1,     1,     5,
       2,     1,     3,     1,     3,     1,     1,     1,     4,     1,
       3,     1,     2,     5,     4,     1,     3,     1,     3,     1,
       3,     4,     4,     5,     2,     1,     3,     1,     3,     1,
       1,     3,     2,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     9,     0,     0,     0,     0,     0,     0,     0,     4,
       5,     8,     6,     7,     0,     0,     0,     0,     0,     0,
       0,     0,     1,     3,    20,     0,    11,     0,    44,     0,
       0,     0,     0,    29,     0,     0,    27,    25,     0,    21,
      26,     0,    18,    16,     0,    12,    17,     0,     0,     0,
      54,    49,     0,    45,    50,     0,     0,     0,    31,     0,
      28,    42,     0,    23,    19,     0,    14,    10,    52,    53,
       0,    47,    43,     0,     0,     0,    32,    30,    22,     0,
      13,     0,    46,     0,    51,     0,     0,     0,     0,    39,
       0,    35,    24,    15,    48,    34,    20,    21,     0,    37,
       0,    33,    36,     0,    40,    38,    41
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     7,     8,     9,    43,    44,    65,    45,    46,    10,
      37,    88,    62,    39,    40,    11,    58,    59,    33,    89,
      90,    98,    99,    12,    13,    51,    52,    70,    53,    54,
      55
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -48
static const yysigned_char yypact[] =
{
      30,   -48,    -6,    -1,    11,     8,    13,    48,    30,   -48,
     -48,   -48,   -48,   -48,    26,    37,    31,    40,    32,    43,
       3,    34,   -48,   -48,   -48,    -7,   -48,     1,   -48,    -5,
      42,     3,    45,   -48,    46,     2,   -48,   -48,    47,   -48,
     -48,    29,   -48,   -48,    49,   -48,   -48,    38,    38,    -3,
     -48,   -48,    50,   -48,   -48,    53,    44,    55,     3,    51,
     -48,   -48,    52,    56,   -48,    54,    58,   -48,   -48,   -48,
      57,    59,   -48,    38,    63,    23,   -48,   -48,   -48,     2,
     -48,    29,   -48,    -3,   -48,    60,    61,    25,    62,   -48,
      65,   -48,   -48,   -48,   -48,   -48,    63,     6,    66,    64,
       1,   -48,   -48,    25,    -5,   -48,   -48
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -48,    75,   -48,   -48,    67,   -33,   -10,   -40,   -48,   -48,
      84,    68,     9,   -35,   -48,   -48,    69,    33,   -48,    70,
     -48,   -13,    17,   -48,   -48,    90,    -9,    14,   -47,   -48,
     -44
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -24
static const yysigned_char yytable[] =
{
      63,    66,    71,    68,    69,    47,    48,    47,    48,    30,
      14,    14,    18,    35,    18,    49,    16,    36,    16,    14,
      50,    41,    50,    31,    79,    42,    36,   -23,    18,    84,
      -2,     1,    20,     2,     3,     4,    71,    21,     5,     6,
      86,    66,    86,    87,    63,    35,    16,    36,    22,    36,
      24,    25,    97,    42,    27,    26,    28,    29,    34,    56,
      60,    61,    64,    50,    67,    72,    73,   104,    74,    75,
      17,    93,    77,    78,    79,    80,    81,    83,    82,    85,
     101,   100,   103,    23,    95,    96,    15,   102,    92,    32,
     105,    76,    91,    38,    19,   106,     0,    94,     0,     0,
      57
};

static const yysigned_char yycheck[] =
{
      35,    41,    49,    47,    48,    10,    11,    10,    11,     6,
      17,    17,    17,    20,    17,    20,    17,    24,    17,    17,
      25,    20,    25,    20,    18,    24,    24,    21,    17,    73,
       0,     1,    24,     3,     4,     5,    83,    24,     8,     9,
      17,    81,    17,    20,    79,    20,    17,    24,     0,    24,
      24,    14,    87,    24,    14,    24,    24,    14,    24,    17,
      15,    15,    15,    25,    15,    15,    13,   100,    24,    14,
       3,    81,    21,    21,    18,    21,    18,    18,    21,    16,
      15,    19,    18,     8,    24,    24,     2,    21,    79,    20,
     103,    58,    75,    25,     4,   104,    -1,    83,    -1,    -1,
      30
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,     4,     5,     8,     9,    27,    28,    29,
      35,    41,    49,    50,    17,    36,    17,    30,    17,    51,
      24,    24,     0,    27,    24,    14,    24,    14,    24,    14,
       6,    20,    42,    44,    24,    20,    24,    36,    37,    39,
      40,    20,    24,    30,    31,    33,    34,    10,    11,    20,
      25,    51,    52,    54,    55,    56,    17,    45,    42,    43,
      15,    15,    38,    39,    15,    32,    33,    15,    56,    56,
      53,    54,    15,    13,    24,    14,    43,    21,    21,    18,
      21,    18,    21,    18,    56,    16,    17,    20,    37,    45,
      46,    48,    38,    32,    53,    24,    24,    39,    47,    48,
      19,    15,    21,    18,    31,    47,    52
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:
#line 205 "cfg_parser.y"
    {
    CFG_YPRINTF(( "Line %d: Syntax Error\n", cfg_lex_line_number));
    if (CFG_OK == cfg_yerrno) {cfg_yerrno = CFG_INVALID_INPUT;};
}
    break;

  case 10:
#line 212 "cfg_parser.y"
    {
    cfg_map_add_from_grammar( cfg_get_config_flowlabels( current_config),
                              yyvsp[-3].string, yyvsp[-1].array, "Flowlabel");
}
    break;

  case 11:
#line 219 "cfg_parser.y"
    {
    yyval.string = yyvsp[0].string;
}
    break;

  case 13:
#line 226 "cfg_parser.y"
    {
    yyval.array = yyvsp[-1].array;
}
    break;

  case 15:
#line 233 "cfg_parser.y"
    {
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
}
    break;

  case 16:
#line 240 "cfg_parser.y"
    {
    cfg_map_variable_values( &yyval.array, cfg_get_config_flowlabels( current_config),
                             yyvsp[0].string, "Flowlabel", cfg_string_clone);
    FREE(yyvsp[0].string);
}
    break;

  case 17:
#line 246 "cfg_parser.y"
    {
    CFG_YCHECK( cfg_array_create_singleton( &yyval.array, yyvsp[0].string));
}
    break;

  case 19:
#line 257 "cfg_parser.y"
    {
    cfg_map_add_from_grammar( cfg_get_config_sensors( current_config),
                              yyvsp[-3].string, yyvsp[-1].array, "Sensor");
}
    break;

  case 20:
#line 264 "cfg_parser.y"
    {
    yyval.string = yyvsp[0].string;
}
    break;

  case 22:
#line 271 "cfg_parser.y"
    {
    yyval.array = yyvsp[-1].array;
}
    break;

  case 24:
#line 278 "cfg_parser.y"
    {
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
}
    break;

  case 25:
#line 285 "cfg_parser.y"
    {
    cfg_map_variable_values( &yyval.array, cfg_get_config_sensors( current_config),
                             yyvsp[0].string, "Sensor", cfg_string_clone);
    FREE(yyvsp[0].string);
}
    break;

  case 26:
#line 291 "cfg_parser.y"
    {
    CFG_YCHECK( cfg_array_create_singleton( &yyval.array, yyvsp[0].string));
}
    break;

  case 28:
#line 302 "cfg_parser.y"
    {
    cfg_map_add_from_grammar( cfg_get_config_domains(current_config),
                              yyvsp[-2].string, CFG_CAST( cfg_array_t, current_domain),
                              "Domain");
    current_domain = NULL;
}
    break;

  case 33:
#line 320 "cfg_parser.y"
    {
    if (current_domain == NULL) {
        CFG_YCHECK( cfg_map_create( &current_domain));
    }
    CFG_YCHECK( cfg_map_add( current_domain, yyvsp[-3].string, yyvsp[-1].array));
}
    break;

  case 34:
#line 329 "cfg_parser.y"
    {
    /* We enforce the internal struct of a path var in the grammar,
       but once it parses, we can ignroe the internal struct, just turn
       it back into a simple string */
    int length = strlen( yyvsp[-2].string);
    char *name;
    CFG_YALLOCATE( char, name, (strlen( yyvsp[-2].string) + strlen( yyvsp[0].string) + 2));
    strcpy( name, yyvsp[-2].string);
    strcpy(name + length, ":");
    strcpy(name + length + 1, yyvsp[0].string);
    FREE( yyvsp[-2].string);
    FREE( yyvsp[0].string);
    yyval.string = name;
}
    break;

  case 36:
#line 347 "cfg_parser.y"
    {
    yyval.array = yyvsp[-1].array;
}
    break;

  case 38:
#line 354 "cfg_parser.y"
    {
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
}
    break;

  case 39:
#line 361 "cfg_parser.y"
    {
    cfg_map_variable_values( &yyval.array, current_domain, yyvsp[0].string, "Path", cfg_path_clone);
    FREE(yyvsp[0].string);
}
    break;

  case 40:
#line 366 "cfg_parser.y"
    {
    cfg_path_cross_product( &yyval.array, yyvsp[-2].array, yyvsp[0].array, NULL);
    cfg_array_destroy( yyvsp[-2].array, cfg_free);
    cfg_array_destroy( yyvsp[0].array, cfg_free);
}
    break;

  case 41:
#line 372 "cfg_parser.y"
    {
    cfg_path_cross_product( &yyval.array, yyvsp[-3].array, yyvsp[-1].array, yyvsp[0].array);
    cfg_array_destroy( yyvsp[-3].array, cfg_free);
    cfg_array_destroy( yyvsp[-1].array, cfg_free);
    cfg_array_destroy( yyvsp[0].array, cfg_daterange_destroy);
}
    break;

  case 42:
#line 382 "cfg_parser.y"
    {
    CFG_YCHECK( cfg_map_add( cfg_get_config_properties( current_config),
                                                        yyvsp[-2].string, yyvsp[-1].string));
}
    break;

  case 43:
#line 390 "cfg_parser.y"
    {
    cfg_map_add_from_grammar( cfg_get_config_dates( current_config),
                              yyvsp[-3].string, yyvsp[-1].array, "Date Range");
}
    break;

  case 44:
#line 397 "cfg_parser.y"
    {
    yyval.string = yyvsp[0].string;
}
    break;

  case 46:
#line 404 "cfg_parser.y"
    {
    yyval.array = yyvsp[-1].array;
}
    break;

  case 48:
#line 411 "cfg_parser.y"
    {
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
}
    break;

  case 49:
#line 418 "cfg_parser.y"
    {
    cfg_map_variable_values( &yyval.array, cfg_get_config_dates( current_config),
                             yyvsp[0].string, "Date Range", cfg_daterange_clone);
    FREE(yyvsp[0].string);
}
    break;

  case 50:
#line 424 "cfg_parser.y"
    {
    CFG_YCHECK( cfg_array_create_singleton( &yyval.array, yyvsp[0].daterange));
}
    break;

  case 51:
#line 430 "cfg_parser.y"
    {
    CFG_YCHECK( cfg_daterange_create( &yyval.daterange, yyvsp[-2].date, yyvsp[0].date));
}
    break;

  case 52:
#line 435 "cfg_parser.y"
    {
    CFG_YCHECK( cfg_daterange_create_before( &yyval.daterange, yyvsp[0].date));
}
    break;

  case 53:
#line 440 "cfg_parser.y"
    {
    CFG_YCHECK( cfg_daterange_create_after( &yyval.daterange, yyvsp[0].date));
}
    break;

  case 54:
#line 445 "cfg_parser.y"
    {
    struct timeval tv;
    skStringParseDatetime(&tv, yyvsp[0].string, NULL);
    CFG_YCHECK( cfg_date_create( CFG_CAST_PTR( cfg_date_t, yyval.date), tv.tv_sec));
}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 1529 "cfg_parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 480 "cfg_parser.y"



/*
 * Adds declaration to proper map, printing friendly error msg if item
 * already defined.
 */
static void cfg_map_add_from_grammar(
    cfg_map_t      *map,
    char           *key,
    cfg_array_t    *value,
    const char     *label)
{
  char *key_clone;
  CFG_YALLOCATE( char, key_clone, strlen( key) + 1);
  strcpy( key_clone, key);
  if (CFG_DATA_OVERWRITTEN == cfg_map_add( map, key, value) ||
      CFG_DATA_OVERWRITTEN == cfg_map_add( cfg_vars_map, key_clone, NULL)) {
        CFG_YPRINTF(( "Line %d: %s variable $%s redefined!\n",
                      cfg_lex_line_number, label, key));
        if (CFG_OK == cfg_yerrno) {cfg_yerrno = CFG_INVALID_INPUT;};
    }
}


/*
 * Returns the value of a variable, from the appropraite map, printing
 * friendly error msg if not found. Clones variable's values, so that
 * free doesn't crash later.
 */
static void cfg_map_variable_values(
    cfg_array_t               **result,
    const cfg_map_t            *map,
    const char                 *key,
    const char                 *label,
    const cfg_clone_function_t  clone_function)
{
    cfg_array_t *values = cfg_map_assoc( map, key);
    CFG_YCHECK( cfg_array_create( result));
    if (values == NULL) {
        CFG_YPRINTF(( "Line %d: %s variable $%s is not defined!\n",
                       cfg_lex_line_number, label, key));
        if (CFG_OK == cfg_yerrno) {cfg_yerrno = CFG_INVALID_INPUT;};
    } else {
        cfg_array_t *clone;
        CFG_YCHECK( cfg_array_clone( &clone, values, clone_function));
        CFG_YCHECK( cfg_array_concatenate( *result, clone));
    }
}


/*
 * Returns an array of paths generated by combinatorially enumerating
 * the array of sensors and array of flowlabels. Dateranges just gets
 * assinged; and it may be NULL.
 */
static void cfg_path_cross_product(
    cfg_array_t       **result,
    const cfg_array_t  *sensors,
    const cfg_array_t  *flowlabels,
    cfg_array_t        *dateranges)
{
    int i, j;
    CFG_YCHECK( cfg_array_create( result));
    for (i = 0; i < cfg_get_array_length( sensors); i++) {
        for (j = 0; j < cfg_get_array_length( flowlabels); j++) {
            cfg_path_t *path;
            CFG_YCHECK( cfg_path_create( &path,
                                         cfg_get_array_element(sensors, i),
                                         cfg_get_array_element( flowlabels, j),
                                         dateranges));
            CFG_YCHECK( cfg_array_add( *result, path));
        }
    }
}


/*
 *   Parses a configuration file into a configuration struct.
 *
 *   - config must have already been created, but need not be 'empty';
 *   preexisting data in config is kept.
 *
 *   - error_fn gets called for every error in the code. You can give it
 *   NULL, in which case it defaults to printf.
 *
 *   Returns CFG_OK if file is completely valid, or
 *   CFG_INVALID_INPUT if any parse errors occurred.
 */
cfg_err_t cfg_config_read(
    cfg_config_t               *x,
    FILE                       *input,
    const cfg_printf_function_t error_fn)
{
    cfg_default_printf_function = printf;
    if (error_fn != NULL) {
        cfg_default_printf_function = error_fn;
    }
    current_config = x; /* purser puts data into current_config */
    cfg_map_create( &cfg_vars_map);
    cfg_yerrno = CFG_OK;
    cfg_config_parse(input);
    cfg_map_destroy( cfg_vars_map, cfg_free);
    return cfg_yerrno;
}


/* Yacc calls this function when it encounters an error */
int yyerror(char UNUSED(*s))
{
    return 0;
}

/*
** Local Variables:
** mode:c
** indent-tabs-mode:nil
** c-basic-offset:4
** End:
*/

